import es
import time
import vecmath

def startTicker():
    es.addons.registerTickListener(_ticker)

def stopTicker():
    es.addons.unregisterTickListener(_ticker)

class Holder(object):
    def __init__(self, index, prop, value, secs):
        self.index = index
        self.prop = prop
        self.value = value
        self.secs = time.time() + secs
    def modify(self, now):
        pass
    def doit(self, now):
        es.setindexprop(self.index, self.prop, str(self.value))
        if now >= self.secs:
            return False
        self.modify(now)
        return True

class Linear(Holder):
    def __init__(self, index, prop, value1, value2, secs):
        now = time.time()
        self.index = index
        self.prop = prop
        if ',' in value1:
            self.value1 = vecmath.vector(value1)
            self.value2 = vecmath.vector(value2)
        else:
            self.value1 = float(value1)
            self.value2 = value2
        self.value = self.value1
        self.secs = now + secs
        self.interval = (self.value2 - self.value1)/secs
    def modify(self, now):
        self.value = self.value1 + self.interval*(self.secs-now)

holders = set()

def _ticker():
    if not holders:
        stopTicker()
        return
    expired = set()
    now = time.time()
    for x in holders:
        if not x.doit(now):
            expired.add(x)
    if expired:
        holders.difference_update(expired)


def holdindexprop(index, prop, value, secs):
    holders.add(Holder(index,prop,value,secs))
    startTicker()
    return True

def linearindexprop(index, prop, value1, value2, secs):
    holders.add(Linear(index,prop,value1,value2,secs))
    startTicker()
    return True
